function withData(param) {
    return param < 10 ? '0' + param : '' + param;
}

function getLoopArray(start, end) {
    var start = start || 0;
    var end = end || 1;
    var array = [];
    for (var i = start; i <= end; i++) {
        array.push(withData(i));
    }
    return array;
}

function getMonthDay(year, month) {
    var flag = year % 400 == 0 || (year % 4 == 0 && year % 100 != 0),
        array = null;

    switch (month) {
        case '01':
        case '03':
        case '05':
        case '07':
        case '08':
        case '10':
        case '12':
            array = getLoopArray(1, 31)
            break;
        case '04':
        case '06':
        case '09':
        case '11':
            array = getLoopArray(1, 30)
            break;
        case '02':
            array = flag ? getLoopArray(1, 29) : getLoopArray(1, 28)
            break;
        default:
            array = '月份格式不正确，请重新输入！'
    }
    return array;
}

function getNewDateArry() {
    // 当前时间的处理
    var newDate = new Date();
    var year = withData(newDate.getFullYear()),
        mont = withData(newDate.getMonth() + 1),
        date = withData(newDate.getDate()),
        hour = withData(newDate.getHours()),
        minu = withData(newDate.getMinutes()),
        seco = withData(newDate.getSeconds());

    return [year, mont, date, hour, minu, seco];
}

function dateTimePicker(startYear, endYear, date) {
    // 返回默认显示的数组和联动数组的声明
    var dateTime = [],
        dateTimeArray = [
            [],
            [],
            [],
            [],
            [],
            []
        ];
    var start = startYear || 1978;
    var end = endYear || 2100;
    // 默认开始显示数据
    var defaultDate = date ? [...date.split(' ')[0].split('-'), ...date.split(' ')[1].split(':')] : getNewDateArry();
    // 处理联动列表数据
    /*年月日 时分秒*/
    dateTimeArray[0] = getLoopArray(start, end);
    dateTimeArray[1] = getLoopArray(1, 12);
    dateTimeArray[2] = getMonthDay(defaultDate[0], defaultDate[1]);
    dateTimeArray[3] = getLoopArray(0, 23);
    dateTimeArray[4] = getLoopArray(0, 59);
    dateTimeArray[5] = getLoopArray(0, 59);

    dateTimeArray.forEach((current, index) => {
        dateTime.push(current.indexOf(defaultDate[index]));
    });

    return {
        dateTimeArray: dateTimeArray,
        dateTime: dateTime
    }
}

function commentTimeHandle(dateStr) {
    var publishTime = dateStr / 1000, //获取dataStr的秒数  打印结果--1536230820000
        date = new Date(publishTime * 1000), //获取dateStr的标准格式 console.log(date) 打印结果  Thu Sep 06 2018 18:47:00 GMT+0800 (中国标准时间)
        // 获取date 中的 年 月 日 时 分 秒
        Y = date.getFullYear(),
        M = date.getMonth() + 1,
        D = date.getDate(),
        H = date.getHours(),
        m = date.getMinutes(),
        s = date.getSeconds();
    // 对 月 日 时 分 秒 小于10时, 加0显示 例如: 09-09 09:01
    if (M < 10) {
        M = '0' + M;
    }
    if (D < 10) {
        D = '0' + D;
    }
    if (H < 10) {
        H = '0' + H;
    }
    if (m < 10) {
        m = '0' + m;
    }
    if (s < 10) {
        s = '0' + s;
    }

    var nowTime = new Date().getTime() / 1000, //获取此时此刻日期的秒数
        diffValue = nowTime - publishTime, // 获取此时 秒数 与 要处理的日期秒数 之间的差值
        diff_days = parseInt(diffValue / 86400), // 一天86400秒 获取相差的天数 取整
        diff_hours = parseInt(diffValue / 3600), // 一时3600秒
        diff_minutes = parseInt(diffValue / 60),
        diff_secodes = parseInt(diffValue);

    if (diff_days > 0 && diff_days < 3) { //相差天数 0 < diff_days < 3 时, 直接返出
        return diff_days + "天前";
    } else if (diff_days <= 0 && diff_hours > 0) {
        return diff_hours + "小时前";
    } else if (diff_hours <= 0 && diff_minutes > 0) {
        return diff_minutes + "分钟前";
    } else if (diff_secodes < 60) {
        if (diff_secodes <= 0) {
            return "刚刚";
        } else {
            return diff_secodes + "秒前";
        }
    } else if (diff_days >= 3 && diff_days < 30) {
        return M + '-' + D + ' ' + H + ':' + m;
    } else if (diff_days >= 30) {
        return Y + '-' + M + '-' + D + ' ' + H + ':' + m;
    }
}
module.exports = {
    dateTimePicker: dateTimePicker,
    getMonthDay: getMonthDay,
    timeHandle: commentTimeHandle
}